/***************************************************************************/
/* Demoprogramm DEMO1.C in BORLAND C++ 3.1 fr die Verwendung der          */
/* MODULAR-8 PC-Bibliothek.                                                */
/*                                                                         */
/* Version von DEMO1.C: 1.D.    Stand: 31.01.1994                          */
/*                                                                         */
/* Demonstriert wird insbesondere die Initialisierung der Bibliothek und   */
/* die Benutzung der Fehlerbehandlungsroutine. Die Kommunikation mit der   */
/* ML8 Karte beschrnkt sich auf das Ein- und Ausschalten der Onboard -    */
/* LED und der externen LED.                                               */
/***************************************************************************/

/* Fr BORLAND C++ 3.1: Standard Run-time Libraries auf static oder dynamic
   in Option/Linker/Libraries einstellen */

#include <conio.h>
#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "ml8bib.h"

#define WARTEZEIT	400

void far pascal errorhandler(void);
void waitmillisec(unsigned long msec);

main()
{
	unsigned int	w;
	char			s[80];
	unsigned int	tn;

  ml8_bib_startup(LANGUAGE_C); /* Verwendete Sprache: BORLAND C++ 3.1
				  Die Function ml8_bib_startup mu! vor allen
				  anderen Bibliotheksroutinen aufgerufen werden */

  w=ml8_reset(0, 0x380, 0, 7, 1, * errorhandler, "ROM", 20);

			  /* Kartennummer, Basisadresse, Betriebsart,
				 PC-Interruptkanal, DMA-Kanal, Fehlerbehandlungs-
				 Routine, ML8-Betriebssystem u. Timeout einstellen.
				 Da die Betriebsart = 0 ist, sind IRQ- und DMA-
				 Kanal hier ohne Bedeutung. Achtung!: ml8_reset
				 (oder alternativ ml8_start) mu! vor dem Aufruf
			     aller anderen Bibliotheksroutinen verwendet
				 werden (jedoch nach ml8_bib_startup). */

  if (w>0)
  {
	printf("Fehler bei ml8_reset:\n");
    ml8_get_error_message(s);
    printf("%s\n",s);
	ml8_exit();
    return(1);
  }

  printf("Die eingebaute LED wird nun 10 mal blinken\n");
  for (w=1; w<11; w++)
  {
	ml8_local_led_on();  	   /* oder auch:  ml8_out8_port(0x5C, 0); */
	printf("*");

	waitmillisec(WARTEZEIT);
	ml8_local_led_off(); 	   /* oder auch:  ml8_out8_port(0x5D, 0); */
	waitmillisec(WARTEZEIT);
  }
  printf("\n");


  printf("Die externe LED wird nun 10 mal blinken, falls angeschlossen\n");
  for (w=1; w<11; w++)
  {
	ml8_external_led_on();	   /* oder auch: ml8_out8_port(0x50, 0); */
	printf("*");
	waitmillisec(WARTEZEIT);
	ml8_external_led_off();	   /* oder auch: out8_out8_port(0x51, 0); */
	waitmillisec(WARTEZEIT);
  }
  printf("\n");


  ml8_exit();		/* Am Ende des Hauptprogramm mu die ML8-Bibliothek
			   geschlossen werden. Von besonderer Bedeutung ist
			   dies bei Verwendung von PC-Interrupt und PC-DMA */

  return(0);
}

/* Benutzer-Fehlerbehandlungs-Routine */
void far pascal errorhandler(void)
{
	struct ml8_error_info_type  error_info, *err_p=&error_info;
	int	i;
	char	s80[81];
	char	ch;
	ushort	w;


	ml8_get_error_info(err_p);

	if (err_p->mark==0) return;

	printf("\n\n\nBenutzer-eigene Fehlerbehandlung\n\n");

	if (err_p->ok)
	{
		printf("Die Fehlerbehandlung wurde grundlos aufgerufen\n");
		printf("(mglicherweise direkt vom C-Programm, statt von der Bibliothek)\n");
		getch();
		return;
	}
	if (err_p->errorclass==5)
	{
	  w=ml8_get_message();

	  printf("Die Fehlermeldung wurde durch einen Errorrequest\n");
	  printf("von der MODULAR-4 Karte ausgelst\n\n");
	  printf("Fehler-Request von Karte: ");
	  printf("     SRQ: %X>H\n",w);
	  printf("Bitte eine Taste drcken ");

	  while (!kbhit()) ;
	  return;
	}
	printf("\n");
	if (err_p->statusmap & 128 > 0)
	{
	  printf("Kommunikationsversuch ohne Initialisierung der \n");
	  printf("Bibliothek fr die angewhlte Karte\n");
	  printf("Verwenden Sie ml8_start oder ml4_reset\n");
	  printf("Programm angehalten\n");
	  abort();
	}
	if (err_p->statusmap & 1 > 0)
	{
	  printf("Kommunikationsversuch ohne ausreichende Fehlerbehandlung.\n");
	  printf("Verwenden Sie ml8_clear_error in der Fehlerbehandlungsroutine\n");
	  printf("Die Fehlervariablen enthalten noch den ursprnglichen Fehler.\n\n");
	}
	ml8_get_error_message(s80);
	printf("Fehlernachricht: %s\n",s80);
	printf("Fehlerklasse %d     ",err_p->errorclass);
	printf("Fehler-Code %d\n",err_p->errorcode);
	printf("Fehler aufgetreten bei Ausfhrung von Makro-Befehl %XH\n",err_p->outwords[0]);
	printf("Schnittstellenstatus (Basisadresse) %XH\n",err_p->statusport);

	printf("\nFehler aufgetreten nach Markierung %d\n",err_p->mark);
	ml8_get_mark_message(s80);
	printf("Mark-Nachricht: %s\n",s80);

	printf("\nProgramm weiterfhren <RETURN> oder Abbruch <A/a> ? ");

	ch='x';
	while (strchr("Aa'\r'", ch)==0) ch=getch();
	if (strchr("Aa", ch)>0)
	{
		printf("\nProgramm wird angehalten\n");
		ml8_exit();
		abort();
	}
	else
	{
		printf("\nProgramm wird weitergefhrt\n");
		ml8_clear_error();
		ml8_get_error_message(s80);
		if (strcmp(s80, "")!=0)
		{	printf("ml8_clear_error() lscht die error_message nicht\n");
		}
		w=ml8_clear();
		if (w>0)
		{
		printf("\nml8_clear ist erfolglos. Programm wird angehalten\n");
		ml8_exit();
		abort();
		}
	}
}


/* Wartezeit, lauffhig sowohl unter BORLAND C++ als auch Microsoft C++ */
void waitmillisec(unsigned long msec)	//nur ungenau, Aufloesung > 55 ms
{
	unsigned long	w,
					stop;
	w=CLOCKS_PER_SEC;
	w=clock();

	stop = w +  ((msec * CLOCKS_PER_SEC) / 1000);

	while (w<stop) w=clock();
}
