/*****************************************************************************
*                       Beispielprogramm fr
*                          Funktionsaufruf
*                            Version 1.A
*
*                 Erstellungsdatum : 28.10.96
*                  Letzte nderung :
*                           Status : freigegeben
*                            Autor : S. Schek
*
*
*            (c) 1996 SORCUS Computer GmbH  Heidelberg
*
*************************************************************************
* Kurzbeschreibung: Das Programm installiert das Echtzeitprogramm M8P0311,
* das nur eine Prozedur enthlt. Diese Prozedur (Nr. 2) dient zur Mittel-
* wertbildung mit einem Funktionsaufruf.
* Das Beispiel dient nur zur Veranschaulichung des Funktionsaufrufs und
* hat darber hinaus keine praktische Bedeutung.
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "ml8bib.h"

void far pascal error_handler(void);   /* Prototyp Fehlerbehandlungsroutine */

/*------- Konstanten zur Installierung des Echtzeitprogrammes -------*/

#define RT_NR 		0x311                /* Nummer des Echtzeitprogrammes*/
#define RT_FLAG  	0x980                /* Installierungsflags */
#define TASK    	16                   /* Als TASK 16 installieren */
#define MIDPROC 	2                    /* Mittelwertprozedur*/
#define ML8_ADR  	0x380                /* MODULAR-4/486 Basisadresse*/
#define ANZDATA 	100                  /* Anzahl Daten, uebergeben an Fkt.*/

/* Pfadeinstellungen fuer Echtzeitprogramm bzw. Betriebssystem. */
#define RT_PATH  	"c:\\sorcus\\ml8\\rt\\bc\\beisp\\M8P0311.EXE"
#define OS_PATH  	"c:\\sorcus\\ml8\\osx\\ml8-*.*"


ushort control;               			/* Var. fr Rckgabewerte von ML8BIB*/
unsigned char b;


void Init(void)
{
  /*----------------- Karte und Bibliothek initialisieren --------------------*/
  ml8_bib_startup(LANGUAGE_C);    		/* Bibliothek fr C initialisieren */

  control = ml8_reset(0, ML8_ADR, 0,0,0, error_handler, OS_PATH, 10);

  if (control!=0)	                     /* Initialisierungs-Fehler?*/
	 {
		printf("Fehler beim Initialisieren der MODULAR-4 Karte!\n");
		printf("Fehlerklasse: %2X\n", control>>8);
		printf("Fehlercode: %2X\n", 0xFF & control);
		printf("Programm wird angehalten!");
		ml8_exit();                      /* Verwendung von ML8BIB beenden*/
		exit(0);
	 }


  /*---------------- Echtzeitprogramm laden und installieren -----------------*/
  control = ml8_transfer_and_install(RT_PATH, 0, TASK, RT_NR, 0, RT_FLAG, 0);
  if (control!= 0)                    	/* Ladefehler? */
	 {
		printf("Fehler beim Laden des Echtzeitprogramms!\n");
		printf("Fehlerklasse: %2X\n", control>>8);
		printf("Fehlercode: %2X\n", 0xFF & control);
		printf("Programm wird angehalten!");
		ml8_exit();                      /* Verwendung von ML8BIB beenden*/
		exit(0);
	 }

}

void main()

{
unsigned char data[ANZDATA];  			/* Daten fuer Uebergabe an die Fkt. */
unsigned char mittel;                  /* berechneter Mittelwert*/
ushort i;			                     /* Laufvariable*/
ushort insize;                     		/* Zahl der zurueckgegebenen Bytes */
unsigned char error; 		            /* von der Fkt. zurueckgeg. Fehler */

  clrscr();

	/* MODULAR-4 Karte initialisieren und Echtzeitprogramm installieren */
  Init();

  /* Schreiben von Daten fuer die Uebergabe an die Funktion */
  for (i=0; i < ANZDATA; i++)
	 data[i] = i+1;

  /* Aufruf der Funktion */
  ml8_call_func(TASK, MIDPROC, ANZDATA, data, 2, &insize, &mittel, &error);

  if (error>0)
	 printf("Fehlermeldung der Funktion 2: %2X\n",error);
  else
	 printf("Berechneter Mittelwert: %i", mittel);
	 getchar();

  ml8_exit();
}

