/********************************************************************
*  MLX16_A.H
*
*  This header files sets the API definitions and includes
*  some needed header files.
*
*  Operating System:    DOS
*                       Windows 3.x
*
*  SORCUS Boards:       ML8 - MODULAR-4/486
*                       ML6 - Multi-COM
*                       ML2 - Multi-LAB/2
*
*  Authors:             Dipl.-Ing. H.Doersam
*                       Dipl.-Ing. M.Haecker
*
*  Copyrights:          SORCUS Computer GmbH 1995 .. 1998
*                       All Rights Reserved
********************************************************************/




#ifndef _INC_MLX16_A
#define _INC_MLX16_A


#ifndef _ml_bib_head
#define _ml_bib_head
#endif // !_ml_bib_head


#if defined (WIN32) || defined (__WIN32__)
   #include <windows.h>
#endif



/* for using the ML8 or ML2 library some compiler settings must be
   considered:
   - Code Model must be LARGE
   - Alignment must be 1 byte
*/

#if !defined (WIN32) && !defined (__WIN32__)
   #ifdef _MSC_VER
      #ifndef M_I86LM
    #error Wrong code model!! ('LARGE' necessary)
      #endif
   #elif defined(__WATCOMC__)
      #ifdef __FLAT__
    // 32-bit: no LARGE model necessary
      #else
    #ifndef __LARGE__
       #error Wrong code model!! ('LARGE' necessary)
    #endif
      #endif
   #else
      #ifndef WIN32
      #ifndef __LARGE__
    #error Wrong code model!! ('LARGE' necessary)
      #endif
      #endif
   #endif
#endif





#ifndef _MLXDEFS_
#define _MLXDEFS_

/* By default all procedure declarations are corresponding to the PASCAL
   convention.
   Procedure calls must be far calls
*/
#if defined (_Windows)
   #if defined (__DLL__)
      #define EXPORT        _export far pascal
      #define PFAR          far pascal
   #else
      #if defined (WIN32) || defined (__WIN32__) 
    #define EXPORT     far pascal
    #define PFAR       
      #else
    #define EXPORT     far pascal
    #define PFAR       far pascal
      #endif
   #endif
#elif defined (_MSC_VER)               /* Microsoft C (MS-DOS) */
   #ifndef WIN32
      #define EXPORT           far pascal
      #define PFAR             far pascal
   #else
      #define EXPORT           pascal
      #define PFAR
      #define ML10API       _extern
   #endif
#elif defined (__WATCOMC__)         /* Watcom C */
   #if defined (__FLAT__)           /* 32 bit */
      #define PFAR             pascal
      #define EXPORT           far pascal
      #define ML10API
   #else
      #define PFAR             far pascal
      #define EXPORT           far pascal
   #endif
#else                                  /* MS-DOS: Borland C */
   #define EXPORT              far pascal
   #define PFAR             far pascal
#endif

#define ML10API

#endif // !_MLXDEFS_




#ifndef _MSC_VER
  #pragma pack(1)
#endif



#include <MLXDEF.H>
#include <MLX16_T.H>
#include <MDDCPS.H>
#include <MLX16_P.H>




#endif // !_INC_MLX16_A

