(***************************************************************************)
(* Demoprogramm DEMO1.PAS in TURBO PASCAL 6.0 u. 7.0 fr die Verwendung    *)
(* der MODULAR-8 PC-Bibliothek.                                            *)
(*                                                                         *)
(* Version von DEMO1.PAS: 1.B.    Stand: 25.02.1993                        *)
(*                                                                         *)
(* Demonstriert wird insbesondere die Initialisierung der Bibliothek und   *)
(* die Benutzung der Fehlerbehandlungsroutine. Die Kommunikation mit der   *)
(* ML8-Karte beschrnkt sich auf das Ein- und Ausschalten der Onboard -    *)
(* LED und der externen LED.                                               *)
(***************************************************************************)

{$V-}

USES ML8BIB, ML8ERROR, CRT;

VAR
	w : WORD;
	s : STRING;
BEGIN
  ml8_bib_startup($100);  { Verwendete Sprache: TURBO PASCAL 6.0
                            Die Prozedur ml8_bib_startup mu! vor allen
                            anderen Bibliotheksroutinen aufgerufen werden }
  s:='ROM';
  w:=ml8_reset(0, $380, 0, 7, 1, @error_handler, s, 20);

                           { Kartennummer, Basisadresse, Betriebsart,
                             PC-Interruptkanal, DMA-Kanal, Fehlerbehandlungs-
                             Routine, ML8-Betriebssystem u. Timeout einstellen.
                             Da die Betriebsart = 0 ist, sind IRQ- und DMA-
                             Kanal hier ohne Bedeutung. Achtung!: ml8_reset
                             (oder alternativ ml8_start) mu! vor dem Aufruf
			     aller anderen Bibliotheksroutinen verwendet
			     werden (jedoch nach ml8_bib_startup).
			     Die Prozedur errorhandler befindet sich in der
			     Unit ERRHAND }
  IF w>0 THEN BEGIN
    writeln('Fehler bei ml8_reset:');
    ml8_get_error_message(s);
    writeln(s);
    ml8_exit;
    halt;
  END;
  clrscr;
  writeln('Die eingebaute LED wird nun 10 mal blinken');
  FOR w:=1 TO 10 DO BEGIN
    ml8_local_led_on;  	   {oder auch:  ml8_out8_port($5C, 0); }
    write('*');
    delay(400);
    ml8_local_led_off; 	   {oder auch:  ml8_out8_port($5D, 0); }
    delay(400);
  END;
  writeln;

  writeln('Die externe LED wird nun 10 mal blinken, falls angeschlossen');
  FOR w:=1 TO 10 DO BEGIN
	ml8_external_led_on;	{oder auch:  ml8_out8_port($50, 0); }
    write('*');
    delay(400);
    ml8_external_led_off;	{oder auch:  ml8_out8_port($51, 0); }
    delay(400);
  END;
  writeln;

  ml8_exit;                { Am Ende des Hauptprogramm mu die ML8-Bibliothek
                             geschlossen werden. Von besonderer Bedeutung ist
			     dies bei Verwendung von PC-Interrupt und PC-DMA }
END.
