{****************************************************************************}
{**                       Beispielprogramm fuer                             **}
{**                         Funktionsaufruf                                **}
{**                           Version 1.B                                  **}
{**                                                                        **}
{**                 Erstellungsdatum : 7.6.94                              **}
{**                  Letzte nderung : 28.10.96 (SJS)                      **}
{**                           Status : freigegeben                         **}
{**                            Autor : H. Haas                             **}
{**                                                                        **}
{**                                                                        **}
{**          (c) 1994..1996 SORCUS Computer GmbH  Heidelberg               **}
{**                                                                        **}
{****************************************************************************}
{** Kurzbeschreibung: Das Programm installiert das Echtzeitprogramm 311H,  **}
{** das nur eine Prozedur enthlt. Diese Prozedur (Nr 2) dient zur Mittel- **}
{** wertbildung mit einem Funktionsaufruf.                                 **}
{** Das Beispiel dient nur zur Veranschaulichung des Funktionsaufrufs und  **}
{** hat darueber hinaus keine praktische Bedeutung.                        **}
{****************************************************************************}


PROGRAM Mittel;
USES ml8bib,ml8error;

CONST
      {------- Konstanten zur Installierung des Echtzeitprogrammes -------}
      {(mp soll heien MessProgramm)}
      RT_NR   = $311;                  {Nummer des Echtzeitprogrammes}
      RT_FLAG = $180;                  {Installierungsflags des Echtzeitpgms}
      TASK    = 16;                    {Als TASK 16 installieren }
      MIDPROC = 2;                     {Mittelwertprozedur}

      ML8_ADR = $380;                  {MODULAR-4/486 Basisadresse}

      {* Pfadeinstellungen fuer Echtzeitprogramm bzw. Betriebssystem. *}
      RT_PATH :STR80 = 'c:\sorcus\ml8\rt\pascal\beisp\M8P0311.EXE';
      OS_PATH :STR80 = 'c:\sorcus\ml8\osx\ml8-*.*';

VAR
      control    : WORD;               { Var. fuer Rueckgabewerte von ML8BIB}
      b          : BYTE;


PROCEDURE Init;
BEGIN
  {----------------- Karte und Bibliothek initialisieren --------------------}
  ml8_bib_startup(LANGUAGE_PASCAL);    {Bibliothek fuer Pascal initialisieren }

  control := ml8_reset(0, ML8_ADR, 0,0,0, @error_handler, OS_PATH, 10);

  IF control<>0 THEN                   {Initialisierungs-Fehler?}
    BEGIN
      WRITELN('Fehler beim Initialisieren der MODULAR-4 Karte!');
      WRITELN('Fehlerklasse: ',HI(control),'; Fehlercode: ',LO(control));
      WRITELN('Programm wird angehalten!');
      ml8_exit;                        {Verwendung von ML8BIB beenden}
      HALT;
    END;

  {---------------- Echtzeitprogramm laden und installieren -----------------}
  control := ml8_transfer_and_install(RT_PATH, 0, TASK, RT_NR, 0, RT_FLAG, 0);
  IF control<>0 THEN                   {Ladefehler?}
    BEGIN
      WRITELN('Fehler beim Laden des Programmes ');
      WRITELN('Fehlerklasse: ',HI(control),'; Fehlercode: ',LO(control));
      WRITELN('Programm wird angehalten!');
      ml8_exit;                        {Verwendung von ML8BIB beenden}
      HALT;
    END;

END;



CONST ANZDATA = 100;                   { Anzahl Byte, an Fkt. uebergeben }

VAR data : ARRAY[1..ANZDATA] OF BYTE;  { Daten fuer die bergabe an die Fkt. }
    m : BYTE;                          { berechneter Mittelwert}
    i      : INTEGER;                  { Laufvariable}
    insize : WORD;                     { Zahl der zurueckgegebenen Bytes}
    error  : BYTE;                     { von der Fkt. zurueckgegebener Fehler}

BEGIN
  { MODULAR-4 Karte initialisieren und Echtzeitprogramm installieren}
  Init;

  {Schreiben von Daten fuer die bergabe}
  FOR i := 1 TO ANZDATA DO
    data[i] := i;

  {* Aufruf der Funktion *}
  ml8_call_func(TASK, MIDPROC, ANZDATA, data, 1, insize, m, error);

  IF error>0 THEN
    WRITELN('Fehlermeldung der Funktion 2: ',error)
  ELSE
    WRITELN('Berechneter Mittelwert: ',m);

  readln;
  ml8_exit;
END.